/*
 * Nomen - a New Opensource Mugen Editor by Nobun
 *
 *
 *  Copyright (C) 2011  Nobun
 *  http://mugenrebirth.forumfree.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program (GPL.txt).  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************/

#ifndef DLG_COMPARE_H
#define DLG_COMPARE_H

#include <QDialog>
#include <QGraphicsScene>
#include <QGraphicsItem>
#include <QProgressBar>
 
#include "ui_dlgCompare.h"
#include "dlgCompare.h"
#include "../minsff/Sff.h"



class DlgCompare : public QDialog
{
    Q_OBJECT
    
protected:
    //This function exists in order to forbid you to close this dialog using "X"
    void closeEvent(QCloseEvent * event);
    
private:
    QGraphicsScene * scene1;
    QGraphicsScene * scene2;
    SffItem * SffItem_scene1;
    SffItem * SffItem_scene2;
    char zoomfactor;
    bool allowclose;
    void init_cutted_sffs();
 
public:
    Ui::DlgCompareDLG ui;
    DlgCompare(QWidget * parent, Sff * _sff1, Sff * _sff2, Sff * _sff3, QProgressBar * _pbar, Sff * _sff4, Sff * _sff5);
    ~DlgCompare();
    
public:
   Sff * orgsff1;
   Sff * orgsff2;
   Sff * sff;
   Sff * cutted_sff1;
   Sff * cutted_sff2;
   QWidget * _parent_;
   
private slots:
   void slotZoomIn();
   void slotZoom1();
   void slotZoomOut();
   
   void slotBg(int value);
   void slotScrollImage(int value);
   
   void slot1();
   void slot2();
   void slot4(); //3 doesn't exist (3 = 1)
};
 
 
#endif

