/*
 * Nomen - a New Opensource Mugen Editor by Nobun
 * FOR PERFECT_SFFV1_ONLY
 *
 *  Copyright (C) 2011  Nobun
 *  http://mugenrebirth.forumfree.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program (GPL.txt).  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************/

#include "Sff.h"
#include "SffHandler.h"
#include "SffV1/SffV1.h"
 

Sff::~Sff() {
  sffdata.clear();
  paldata.clear();	
}


Sff::Sff() {
  this->clear();
}


void Sff::clear() {
  sffdata.clear();
  paldata.clear();
  filename.clear();
}




/*

bool Sff::saveSff(QString & _filename, char sff_type) {

  SffHandler * sffh = select_sff_plugin_writer(_filename, sff_type);
  //unlike select_sff_plugin_reader, 
  //select_sff_plugin_writer DOESN'T invoke PLUGIN->write(filename) so
  //why it is invoked here
  
  sffh->sffdata = sffdata;
  sffh->paldata = paldata;
  sffh->removeDuplicates = removeDuplicates;
  bool temp = sffh->write(_filename);
  delete sffh;
  if(temp==true) isSaved = true;
  return temp;
  
  return true;
}

*/


SffData * Sff::item(int itemID) {
  return &sffdata[itemID];	
}


int Sff::searchItem(int groupno, int imageno) {
  for(int a = 0; a < sffdata.size(); a++) {
    if(sffdata[a].groupno == groupno && sffdata[a].imageno == imageno) return a;
  }
  return -1;
}


int Sff::searchItem(int groupno) {
  for(int a = 0; a < sffdata.size(); a++) {
    if(sffdata[a].groupno == groupno) return a;
  }
  return -1;
}


QList<int> Sff::usedPalGroups() {
  QList <int> values;
  for(int a=0; a<paldata.size(); a++) {
	bool new_value=true;
    for(int b=0; b<values.size(); b++) {
	  if(paldata[a].groupno == values[b]) { new_value=false; break; }
    }
    if(new_value==true) { values.append(paldata[a].groupno); }
  }
  return values;
}


QList<int> Sff::usedSprGroups() {
  QList <int> values;
  for(int a=0; a<sffdata.size(); a++) {
	bool new_value=true;
    for(int b=0; b<values.size(); b++) {
	  if(sffdata[a].groupno == values[b]) { new_value=false; break; }
    }
    if(new_value==true) { values.append(sffdata[a].groupno); }
  }
  return values;
}


QList<int> Sff::searchItems(int groupno) {
  QList <int> values;
  for(int a = 0; a < sffdata.size(); a++) {
    if(sffdata[a].groupno == groupno) values.append(a);
  }
  return values;
}

