/*
 * Nomen - a New Opensource Mugen Editor by Nobun
 *
 * MODIFYED VERSION FOR PERFECT_SFFv1
 *
 *
 *  Copyright (C) 2011  Nobun
 *  http://mugenrebirth.forumfree.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program (GPL.txt).  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************/
 
 
#include "SffHandler.h"
#include <QApplication>


SffHandler::SffHandler() {
   this->removeDuplicates = true;	
}


const int SffHandler::sffGroupCount() {
  QList <int> values;
  for(int a=0; a<sffdata.size(); a++) {
	bool new_value=true;
    for(int b=0; b<values.size(); b++) {
	  if(sffdata[a].groupno == values[b]) { new_value=false; break; }
    }
    if(new_value==true) { values.append(sffdata[a].groupno); }
  }
  return values.size();	
}


void SffHandler::searchDuplicateImages() {
  for(int a = 0; a < sffdata.size(); a++) {
     for(int b = a+1; b < sffdata.size(); b++) {
	   if(sffdata[a].image == sffdata[b].image && sffdata[a].linked == -1) sffdata[b].linked = a;    
	     //&& sffdata[a].linked == -1 -> if false it avoid a re-check of a image just linked before
     }
  }
}


QString SffHandler::scanSff(bool rgbSupported) { 
  QString str; str.clear();
  for(int a = 0; a < sffdata.size(); a++) {
	 //if rgb is not supported, return an error if an Rgb Image found
	 if(rgbSupported == false) {
	   if(sffdata[a].image.format() != QImage::Format_Indexed8) {
		   
		 str = qApp->translate("SffHandler", "This sff format doesn't support Rgb Images\n\n"
		                              "Found Rgb Image at position %1 (image %2,%3)") 
		                              .arg(a+1) .arg(sffdata[a].groupno) .arg(sffdata[a].imageno);
		 return str;   
       }
     }
	 
	 //check for duplicate infos....
     for(int b = a+1; b < sffdata.size(); b++) {
	   if(sffdata[a].groupno == sffdata[b].groupno && sffdata[a].imageno == sffdata[b].imageno)
	   {
	     str = qApp->translate("SffHandler", "Two or more images with same groupno, imageno\n\n"
	                                  "Found image %1,%2 at position %3 and at position %4") 
	               .arg(sffdata[a].groupno) .arg(sffdata[a].imageno)
	               .arg(a+1) .arg(b+1); 
	     return str;
       }
     }
  }
  
  return str;
}

