/*
 * Nomen - a New Opensource Mugen Editor by Nobun
 *
 *
 *  Copyright (C) 2011  Nobun
 *  http://mugenrebirth.forumfree.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program (GPL.txt).  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************/

#ifndef SFF_WIDGET_H
#define SFF_WIDGET_H
 
#include "ui_SffWidget.h"
#include "Sff.h"
#include "SffItem.h"

/*
sffWidget is the class that implements the widget for sff management
*/ 

//! This class implements the widget for Sff Management 
class SffWidget : public QWidget
{
    Q_OBJECT
    
private:
    QGraphicsScene * sffScene;
    SffItem * actualSffItem;
    char zoomfactor;
 
public:
    Ui::sffWidgetWID ui;
    SffWidget(QWidget * parent, Sff * sff);
    ~SffWidget();
    
public:
   Sff * sff;
   
public:
   void refreshScene();

private slots:
   void sffSceneChanged(const QList<QRectF> & region);
   void slotUpdateX(int value);
   void slotUpdateY(int value);
   void slotUpdateGroupno(int value);
   void slotUpdateImageno(int value);
   void slotZoomIn();
   void slotZoom1();
   void slotZoomOut();
   void slotBg(int value);
   void slotScrollImage(int value);
   void slotAddFrame();
   void slotRemoveFrame();
   void slotSearchImage();
   void slotCurrentSpriteChangePal();
   void slotPalSection();
};
 
 
#endif

